<html xmlns:th="http://www.thymeleaf.org" xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
	layout:decorate="layouts/defaultTemplate">

<body>
	<!-- Content fragment for the layout -->
	<div layout:fragment="content">
		<!-- Form for creating a new movie, with action mapped to the 'createMovie' endpoint -->
		<form action="#" th:action="@{createMovie}" th:object="${movieModel}" method="post" class="p-[18rem]">
			<table>
				<!-- Movie name field row -->
				<tr class="input input-bordered flex items-center gap-2">
					<td>Name:</td>
					<td>
						<!-- Input field bound to 'name' from the 'movieModel' object -->
						<input type="text" th:field="*{name}">
					</td>
					<td>
						<!-- Display validation error message for 'name' if present -->
						<h5 style="color: red" th:if="${#fields.hasErrors('name')}" th:errors="*{name}">Name Error</h5>
					</td>
				</tr>
				<!-- Author field row -->
				<tr class="input input-bordered flex items-center gap-2">
					<td>Author:</td>
					<td>
						<!-- Input field bound to 'author' from the 'movieModel' object -->
						<input type="text" th:field="*{author}">
					</td>
					<td>
						<!-- Display validation error message for 'author' if present -->
						<h5 style="color: red" th:if="${#fields.hasErrors('author')}" th:errors="*{author}">Author Error
						</h5>
					</td>
				</tr>
				<!-- Genre field row -->
				<tr class="input input-bordered flex items-center gap-2">
					<td>Genre:</td>
					<td>
						<!-- Input field bound to 'genre' from the 'movieModel' object -->
						<input type="text" th:field="*{genre}">
					</td>
					<td>
						<!-- Display validation error message for 'genre' if present -->
						<h5 style="color: red" th:if="${#fields.hasErrors('genre')}" th:errors="*{genre}">Genre Error
						</h5>
					</td>
				</tr>
				<!-- Price field row -->
				<tr class="input input-bordered flex items-center gap-2">
					<td>Price:</td>
					<td>
						<!-- Input field bound to 'price' from the 'movieModel' object -->
						<input type="number" th:field="*{price}" step="0.01">
					</td>
					<td>
						<!-- Display validation error message for 'price' if present -->
						<h5 style="color: red" th:if="${#fields.hasErrors('price')}" th:errors="*{price}">Price Error
						</h5>
					</td>
				</tr>
				<!-- Description field row -->
				<tr class="input input-bordered flex items-center gap-2">
					<td>Description:</td>
					<td>
						<!-- Input field bound to 'description' from the 'movieModel' object -->
						<textarea th:field="*{description}"></textarea>
					</td>
					<td>
						<!-- Display validation error message for 'description' if present -->
						<h5 style="color: red" th:if="${#fields.hasErrors('description')}" th:errors="*{description}">
							Description Error</h5>
					</td>
				</tr>
				<!-- Stock Quantity field row -->
				<tr class="input input-bordered flex items-center gap-2">
					<td>Stock Quantity:</td>
					<td>
						<!-- Input field bound to 'stockQuantity' from the 'movieModel' object -->
						<input type="number" th:field="*{stockQuantity}" min="0">
					</td>
					<td>
						<!-- Display validation error message for 'stockQuantity' if present -->
						<h5 style="color: red" th:if="${#fields.hasErrors('stockQuantity')}"
							th:errors="*{stockQuantity}">Stock Quantity Error</h5>
					</td>
				</tr>
				<!-- Release Date field row -->
				<tr class="input input-bordered flex items-center gap-2">
					<td>Release Date:</td>
					<td>
						<!-- Input field bound to 'releaseDate' from the 'movieModel' object -->
						<input type="date" th:field="*{releaseDate}">
					</td>
					<td>
						<!-- Display validation error message for 'releaseDate' if present -->
						<h5 style="color: red" th:if="${#fields.hasErrors('releaseDate')}" th:errors="*{releaseDate}">
							Release Date Error</h5>
					</td>
				</tr>

				<!-- Submit button row -->
				<tr>
					<td colspan="2">
						<!-- Submit button to trigger form submission -->
						<input class="btn btn-primary" type="submit" value="Create Movie" />
					</td>
				</tr>
			</table>

			<br>

			<!-- Section to display validation errors for the entire form -->
			<div th:if="${#fields.hasErrors('*')}">
				<!-- Display a general error message if there are any field errors -->
				List of Errors
			</div>
			<div th:each="err : ${#fields.errors('*')}">
				<!-- Loop through and display each individual field error -->
				<span style="color: red" th:text="${err}" class="fieldError"></span>
			</div>

			<!-- Section to display authentication-related errors -->
			<div th:if="${autherror}">
				<!-- Display authentication error message if present -->
				Authentication Message
			</div>
			<span style="color: red" th:text="${autherror}" class="fieldError"></span>
		</form>
	</div>

</body>

</html>